<?php
/**
 * A UDP connection helper class
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2015 Hub Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 * @todo		Find an interface for hub helper
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
class UdpConnectionHelper extends BaseIpV4ConnectionHelper implements ConnectionHelper {
	/**
	 * Protected constructor
	 *
	 * @return	void
	 */
	protected function __construct () {
		// Call parent constructor
		parent::__construct(__CLASS__);

		// Set protocol
		$this->setProtocolName('udp');
	}

	/**
	 * Creates a half-connected socket resource ("connection") for given
	 * recipient in package data. After you called this method you still need to
	 * connect to the other node.
	 *
	 * @param	$packageData		Raw package data
	 * @return	$socketResource		Socket resource
	 */
	public static function createConnectionFromPackageData (array $packageData) {
		$this->debugBackTrace('[' . __METHOD__ . ':' . __LINE__ . ']:  Unfinished method, packageData[]=' . count($packageData));
	}

	/**
	 * Do the shutdown sequence for this connection helper
	 *
	 * @return	void
	 * @throws	SocketShutdownException		If the current socket could not be shut down
	 * @todo	Implement a filter for ease notification of other objects like the pool
	 */
	public function doShutdown () {
		$this->partialStub('Please implement this method.');
	}
}

// [EOF]
?>
